//
// Example usage of binary morphology tool
// Bala Amavasai (bala@amavasai.org)
//
// $Header: /cvs/mimas2/examples/blob/main.cc,v 1.1.1.1 2005/08/09 15:37:30 engmb Exp $
//


#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_fileoutput.h"
#include "image_mesaoutput.h"
#include "binmorph_tool.h"

using namespace std;
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {

    x11_display display;
    image<int> imagein, imagebin, imageeroded, imagedilated, imageedges, imageout;
    binmorph_tool blob;
    image_mesaoutput< unsigned char > win( &display );

    ifstream file( "../images/stills/jellybeans-256x256.pgm", ios::binary );
    file >> imagein;
    win << imagein << mimas::pause();

    // binarise image - note that imagebin only contains 0s and 1s!!!!
    blob.greyToBinaryOtsu(imagein, imagebin);

    // eroded and dilated versions of imagebin
    blob.erosion(imagebin,imageeroded);
    imageout = imageeroded;
    blob.normaliseToGrey(imageout);
    win << imageout << mimas::pause();

    blob.dilation(imagebin,imagedilated);
    imageout = imagedilated;
    blob.normaliseToGrey(imageout);
    win << imageout << mimas::pause();

    // morphological difference of two images
    blob.difference(imagedilated,imageeroded,imageedges);
    imageout = imageedges;
    blob.normaliseToGrey(imageout);
    win << imageout << mimas::pause();

    // distance map
    // blob.distanceTransform(imageedges,imageout);
    // blob.normaliseToGrey(imageout);
    // win << imageout << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };

  return retVal;
}


